;==============================================================================
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm
;==============================================================================
    .data
        hHeap dd 0
    .code
;==============================================================================
start:
;==============================================================================
    ;-----------------------------------------------------
    ; Create a growable heap with an initial aize of 1MB.
    ;-----------------------------------------------------

    invoke HeapCreate, HEAP_GENERATE_EXCEPTIONS, 100000h, 0
    mov hHeap, eax

    ;----------------------------------------------------------
    ; Allocate a 1MB block from the heap, initialized to zero.
    ;----------------------------------------------------------

    invoke HeapAlloc, hHeap,
                      HEAP_GENERATE_EXCEPTIONS or HEAP_ZERO_MEMORY,
                      100000h
    mov edi, eax

    ;-------------------------------------------------------
    ; Verify that HeapReAlloc does preserve the contents of
    ; the memory block up to its original size.
    ;-------------------------------------------------------

    xor ebx, ebx
    .while ebx < 100000h/4
      mov [edi+ebx*4], ebx
      inc ebx
    .endw

    invoke HeapReAlloc, hHeap,
                        HEAP_GENERATE_EXCEPTIONS or HEAP_ZERO_MEMORY,
                        edi,
                        200000h
    mov edi, eax

    xor ebx, ebx
    .while ebx < 100000h/4
      .if [edi+ebx*4]!= ebx
        print "error",13,10
      .endif
      inc ebx
    .endw

    invoke Sleep, 4000
    print "total(KB)   address    time(ms)",13,10
    print "-------------------------------",13,10
    mov esi, 200000h
    repeat 30
      print " "
      add esi, 100000h
      timer_begin 1, HIGH_PRIORITY_CLASS
        invoke HeapReAlloc, hHeap,
                            HEAP_GENERATE_EXCEPTIONS or HEAP_ZERO_MEMORY,
                            edi, esi
        mov edi, eax
      timer_end
      push eax
      mov eax, esi
      shr eax, 10
      print str$(eax),9,"   "
      print hex$(edi),"h",9," "
      pop eax
      print str$(eax),13,10
    endm

    print chr$(13,10,13,10)
    inkey "Press any key to exit..."
    exit
;==============================================================================
end start
